module Lager(
  Posten,
  artikel, 
  menge,
  posten,
  cent,
  Lager,
  leeresLager,
  einlagern,
  suche, 
  inventur
  ) where

import Data.Maybe(fromJust,listToMaybe)

import Artikel

-- Posten:
data Posten = 
  Posten { artikel :: Artikel
         , menge   ::  Menge
         } deriving Show

posten :: Artikel-> Menge-> Maybe Posten 
posten a m = 
  case preis a m of 
    Just _ -> Just (Posten a m)
    Nothing -> Nothing

cent :: Posten-> Int
cent (Posten a m) = fromJust (preis a m) 

-- Lagerhaltung:
data Lager = Lager [Posten]
             deriving Show

leeresLager :: Lager
leeresLager = Lager []

suche :: Artikel-> Lager-> Maybe Menge
suche a (Lager l) = 
   listToMaybe (map menge (filter ((a ==). artikel) l))

einlagern :: Artikel-> Menge-> Lager-> Lager
einlagern a m (Lager l) =
  let hinein p [] = [p]
      hinein p@(Posten a m) (Posten al ml:l)
         | a == al   = (Posten a (addiere m ml): l)
         | otherwise = (Posten al ml: hinein p l)
  in case posten a m of 
       Nothing -> Lager l
       Just p -> Lager (hinein p l)

inventur :: Lager-> Int
inventur (Lager l) = sum (map cent l)

