module Lager2(
  Posten,
  artikel, 
  menge,
  posten,
  cent,
  Lager,
  leeresLager,
  einlagern,
  suche, 
  inventur
  ) where

import Data.Maybe(fromJust,listToMaybe)

import Artikel
import qualified MapList as M

-- Posten:
data Posten = 
  Posten { artikel :: Artikel
         , menge   ::  Menge
         } deriving Show

posten :: Artikel-> Menge-> Maybe Posten 
posten a m = 
  case preis a m of 
    Just _ -> Just (Posten a m)
    Nothing -> Nothing

cent :: Posten-> Int
cent (Posten a m) = fromJust (preis a m) 

-- Alternative Version des Lagers: 
-- Lager als endliche Abbildung Artikel-> Posten

-- Lagerhaltung:
data Lager = Lager (M.Map Artikel Posten)

leeresLager :: Lager
leeresLager = Lager M.empty

suche :: Artikel-> Lager-> Maybe Menge
suche a (Lager l) = fmap menge (M.lookup a l)

einlagern :: Artikel-> Menge-> Lager-> Lager
einlagern a m (Lager l) =
  case posten a m of 
     Nothing -> Lager l
     Just p -> Lager (M.insert a p l)

inventur :: Lager-> Int
inventur (Lager l) = M.fold (\ (a, p) r-> cent p + r) 0 l

